stages:
    - testes_docker
    - testes
    - build
    - migrate
    - deploy

testar_login:
    image: docker:stable
    stage: testes_docker
    script:
        - docker login $CI_REGISTRY -u kennynuylla -p $Token
    services:
        - docker:stable-dind

tests:
    image: $SDKImage
    stage: testes
    script:
        - dotnet nuget add source $DeployDevServer
        - dotnet test

        
build:
    image: $SDKImage
    stage: build
    script:
        - dotnet nuget add source $DeployDevServer
        - dotnet publish QuineVSGA/QuineVSGA.csproj -c Release -o QuineVSGA/app
    artifacts:
        paths:
            - QuineVSGA/app

migrar:
    image: $SDKImage
    stage: migrate
    script:
        - dotnet nuget add source $DeployDevServer
        - dotnet tool install --global dotnet-ef
        - export PATH="$PATH:/root/.dotnet/tools"
        - dotnet restore Bibliotecas/Bibliotecas.csproj
        - dotnet-ef database update -p Bibliotecas/Bibliotecas.csproj --configuration Prod
    only:
        - master
        - tags


deploy-master:
    image: docker:stable
    stage: deploy
    script:
        - docker login $CI_REGISTRY -u kennynuylla -p $Token
        - docker build -t $CI_REGISTRY/formacao/mestrado/quine-ga .
        - docker push $CI_REGISTRY/formacao/mestrado/quine-ga
    only:
        - master

    services:
        - docker:stable-dind

deploy-dev:
    image: docker:stable
    stage: deploy
    script:
        - docker login $CI_REGISTRY -u kennynuylla -p $Token
        - docker build -t $CI_REGISTRY/formacao/mestrado/quine-ga:dev .
        - docker push $CI_REGISTRY/formacao/mestrado/quine-ga:dev
    only:
        - develop

    services:
        - docker:stable-dind


deploy-tag:
    image: docker:stable
    stage: deploy
    script:
        - docker login $CI_REGISTRY -u kennynuylla -p $Token
        - docker build -t $CI_REGISTRY/formacao/mestrado/quine-ga:$CI_COMMIT_TAG .
        - docker push $CI_REGISTRY/formacao/mestrado/quine-ga:$CI_COMMIT_TAG
    only:
        - tags

    services:
        - docker:stable-dind
